package space

import (
	"context"
)

// @microgen grpc
// @protobuf git.perx.ru/perxis/perxis-go/proto/spaces
// @grpc-addr content.spaces.Spaces
type Spaces interface {
	// Create - создает пространство для размещения контента
	// В процессе создание пространства выполняются следующие шаги:
	// 1. Создается запись о пространстве
	// 2. Создается БД пространства
	// 3. Создается master окружение
	// Шаги могут выполняться в отложенном режиме, при этом пространство может быть недоступно для
	// выполнения любых операций

	Create(ctx context.Context, space *Space) (created *Space, err error)
	Get(ctx context.Context, spaceId string) (space *Space, err error)
	List(ctx context.Context, orgId string) (spaces []*Space, err error)
	Update(ctx context.Context, space *Space) (err error)
	UpdateConfig(ctx context.Context, spaceId string, config *Config) (err error)
	Delete(ctx context.Context, spaceId string) (err error)
}
